#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Dec  6 12:33:19 2017

@author: wsf
"""

import pandas as pd



#加载数据
def processing_data(dataset_filename):
    location = dataset_filename.rfind('.') 
    file_format = dataset_filename[location+1:]
    if file_format == 'csv':
        dataset = pd.read_csv(dataset_filename) 
        index_name = list(dataset.iloc[:,0])
        dataset = dataset.iloc[:,1:]
    else :
        dataset = pd.read_csv(dataset_filename,sep='\t') 
        index_name = list(dataset.iloc[:,0])
        dataset = dataset.iloc[:,1:]
    return index_name,dataset, list(dataset.columns)

#加载标签
def processing_class(labelset_filename):
    location = labelset_filename.rfind('.') 
    file_format = labelset_filename[location+1:]
    if file_format == 'csv':
        temp = pd.read_csv(labelset_filename)
    else:
        temp = pd.read_csv(labelset_filename,sep='\t')
    flag = 0
    if 'Class' in temp.columns :
        flag = 1
        labels = temp.loc[:,'Class']
        label_set = list(labels)
        class_set = list(set(label_set))   
        name_set = list(temp.iloc[:,0])
        return  flag, label_set, class_set, name_set #返回数据集的标签集，标签集的种类
    else :
        label_set = []
        class_set = []
        name_set = []
        return  flag, label_set, class_set, name_set




 
