# -*- coding: utf-8 -*-
"""
Created on Fri Oct 27 17:52:06 2017

@author: as
"""
from sklearn.model_selection import KFold
#函数功能：传入分类方法，进行10折交叉检验，返回测试集
def kFoldTest(clf,raw_data,raw_target):
    predict=[]
    kf = KFold(n_splits=10)    
    for train_index, test_index in kf.split(raw_data):
        #print("TRAIN:", train_index, "TEST:", test_index)#查看如何分割数据
        X_train, X_test = raw_data[[train_index]], raw_data[[test_index]]
        #Y_test在这里没作用，为了数据变量对齐0.0
        Y_train = raw_target[:test_index[0]]+raw_target[test_index[-1]+1:]        
        clf.fit(X_train,Y_train)
        test_target_temp=clf.predict(X_test)
        predict.append(test_target_temp)    
    test_target = [i for temp in predict for i in temp]#将10次测试集展平
    return test_target



#函数功能：统计正确率，以及每个类的正确数
def statistics(raw,test):
    TP=0
    TN=0
    FP=0
    FN=0
    for i in range(len(raw)):
        if raw[i]==0 :
            if test[i]==0:
                TN+=1
            else:
                FP+=1
        else :
            if test[i]==1 :
                TP+=1
            else: 
                FN+=1    
    try:
        Sn=TP/(TP+FN)
    except ZeroDivisionError:
        Sn=0   
    try:
        Sp=TN/(TN+FP)
    except ZeroDivisionError:
        Sp=0
    Acc=(TP+TN)/(TP+FP+TN+FN)
    Avc=(Sn+Sp)/2
    return Sn,Sp,Acc,Avc

if __name__ == '__main__':
    from sklearn import neighbors
    clf=neighbors.KNeighborsClassifier(n_neighbors = 1 )
    print(statistics([0,1,0,0],kFoldTest(clf,[1,2,3,4],[0,1,0,1])))
